package submit.aiwolf.wordwolf;

import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.net.GameInfo;

import java.util.HashMap;
import java.util.List;
import java.util.Map.Entry;


public class maxPattern {

    RolePattern rollPattern= RolePattern.getInstance();
    List<HashMap<Agent,Role>> pattern;
    List<HashMap<Agent,Role>> existsPattern;
    TalkFrequencyModel tf = TalkFrequencyModel.getInstance();

    public HashMap<Agent,Role> getMaxRole(GameInfo gameInfo) {

        double max = 0.0;
        double tmp = 0.0;

        if(existsPattern==null){
            pattern = rollPattern.initRolePattern(gameInfo);
            existsPattern=pattern;
        }else{
            pattern = existsPattern;
        }

        HashMap<Agent,Role> maxRole=pattern.get(0);
        for (HashMap<Agent,Role> phash : pattern) {
            for (Entry<Agent, Role> p : phash.entrySet()) {
                tmp = 1.0;
                double x = tf.getRoleProbability(p.getKey(), p.getValue());
                if (x == 0) {
                    existsPattern.remove(p);
                    break;
                }
                tmp *= x;
                if (tmp < max) {
                    break;
                }
            }
            if (tmp > max) {
                maxRole = phash;
                max = tmp;
            }
        }
        return maxRole;
    }
}
