package submit.aiwolf.wordwolf;

import org.aiwolf.client.lib.Content;
import org.aiwolf.client.lib.DivinationContentBuilder;
import org.aiwolf.client.lib.EstimateContentBuilder;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Judge;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Species;

public class DemoVillager extends DemoBasePlayer {

	@Override
	public void chooseVoteCandidate() {
		werewolves.clear();
		for(Judge j:divinationList) {
			if(j.getResult()==Species.WEREWOLF && (j.getTarget()==me)
					|| isKilled(j.getTarget())) {
				Agent candidate=j.getAgent();
				if(isAlive(candidate)&&!werewolves.contains(candidate))
					werewolves.add(candidate);
			}
		}
		if(werewolves.isEmpty()) {
			if(!aliveOthers.contains(voteCandidate)) {
				voteCandidate=randomSelect(aliveOthers);
			}
		}else {
			if(!werewolves.contains(voteCandidate)) {
				voteCandidate=randomSelect(werewolves);
				if(canTalk) {
					talkQueue.offer(new Content(new EstimateContentBuilder(voteCandidate,Role.WEREWOLF)));
					talkQueue.offer(new Content(new DivinationContentBuilder(voteCandidate)));
				}
			}
		}
	}

	public String whisper() {
		throw new UnsupportedOperationException();
	}

	public Agent attack() {
		throw new UnsupportedOperationException();
	}

	public Agent divine() {
		throw new UnsupportedOperationException();
	}

	public Agent guard() {
		throw new UnsupportedOperationException();
	}
}
